"use strict";
Object.defineProperty(exports, "__esModule", {
    value: true
});
Object.defineProperty(exports, "languages", {
    enumerable: true,
    get: function() {
        return _codeSyntax.languages;
    }
});
var _jsxRuntime = require("mixter/jsx/jsx-runtime");
var _mixter = require("mixter");
var _jsx = require("mixter/jsx");
var _codeSyntax = require("code-syntax");
var _superImpose = require("super-impose");
var _textareaCode = require("textarea-code");
const style = /*css*/ `
:host {
  --caret: #fff;
  --selection: #742;
  --padding: 0;
  position: relative;
  display: block;
  overflow: hidden;
  background: var(--background, transparent);
}
slot {
  display: none;
}
pre,
textarea {
  display: flex;
  white-space: pre;
  padding: 0;
  margin: 0;
  width: 100%;
  height: 100%;
  font-size: inherit;
  line-height: inherit;
  background: transparent;
  color: transparent;
  caret-color: var(--caret);
  outline: none;
  resize: none;
  border: none;
  z-index: 1;
}
pre {
  position: absolute;
  width: auto;
  height: auto;
  z-index: -1;
}
textarea::selection {
  color: var(--color);
  background-color: var(--selection) !important;
}`;
let CodeEditElement = class CodeEditElement extends (0, _mixter).mixter(HTMLElement, (0, _mixter).shadow(), (0, _mixter).events(), (0, _mixter).attrs(class {
    /** The editor's value */ value = '';
    /** Autofocus to the element when page loads */ autoFocus = false;
    /** Whether to autoresize to the height of the contents */ autoResize = false;
    /** Language for syntax highlighting */ language = '';
    /** Theme to use */ theme = '';
    /** Tab size */ tabSize = 2;
    /** Tab style */ tabStyle = 'spaces';
    /** Comment */ comments = '// /* */';
}), (0, _mixter).props(class {
    /** @private */ CodeSyntax = (0, _jsx).element(_codeSyntax.CodeSyntaxElement);
    /** @private */ SuperImpose = (0, _jsx).element(_superImpose.SuperImposeElement);
    /** @private */ TextAreaCode = (0, _jsx).element(_textareaCode.TextAreaCodeElement, {
        extends: 'textarea'
    });
    /** Passing a syntax definition regexp manually */ syntax = {};
    /** @private */ textarea;
    /** @private */ layout;
    /** @private */ height;
    /** @private */ onInput;
    /** @private */ onScroll;
}), (0, _mixter).state(({ $ , effect , reduce  })=>{
    const { part , render  } = (0, _jsx).jsx($);
    const { ref  } = (0, _jsx).refs($);
    $.onInput = reduce(({ textarea  })=>()=>{
            $.value = textarea.value;
        }
    , ()=>{});
    $.onScroll = reduce(({ host  })=>()=>{
            host.dispatchEvent(new Event('scroll', {
                bubbles: true
            }));
        }
    , ()=>{});
    effect(({ autoResize , layout , height , value: _  })=>{
        if (autoResize) {
            // push to the end of the job when height has actually changed
            queueMicrotask(()=>{
                layout.style.height = (height.getBoundingClientRect().height ?? 'auto') + 'px';
            });
        }
    });
    effect(({ autoFocus , textarea  })=>{
        if (autoFocus) {
            // deal with browser autofocus warning on initial load
            setTimeout(()=>{
                textarea.focus();
                // move the caret to the beginning
                setTimeout(()=>textarea.setSelectionRange(0, 0)
                );
            });
        }
    });
    effect(({ root  })=>(0, _mixter).onTextChange(root, (text)=>{
            $.value = text;
        })
    );
    const Content = part(({ SuperImpose , TextAreaCode , CodeSyntax , onScroll , onInput , comments , tabSize , tabStyle , theme , language , syntax , value ,  })=>/*#__PURE__*/ (0, _jsxRuntime).jsxs(_jsxRuntime.Fragment, {
            children: [
                /*#__PURE__*/ (0, _jsxRuntime).jsxs("pre", {
                    ref: ref.height,
                    children: [
                        value,
                        ' '
                    ]
                }),
                /*#__PURE__*/ (0, _jsxRuntime).jsxs(SuperImpose, {
                    part: "layout",
                    ref: ref.layout,
                    onscroll: onScroll,
                    children: [
                        /*#__PURE__*/ (0, _jsxRuntime).jsx(TextAreaCode, {
                            part: "textarea",
                            slot: "leader",
                            ref: ref.textarea,
                            comments: comments,
                            oninput: onInput,
                            tabSize: tabSize,
                            tabStyle: tabStyle,
                            theme: theme,
                            value: value
                        }),
                        /*#__PURE__*/ (0, _jsxRuntime).jsx(CodeSyntax, {
                            part: "syntax",
                            slot: "follower",
                            language: language,
                            syntax: syntax,
                            theme: theme,
                            children: value
                        })
                    ]
                })
            ]
        })
    );
    render(()=>/*#__PURE__*/ (0, _jsxRuntime).jsxs(_jsxRuntime.Fragment, {
            children: [
                /*#__PURE__*/ (0, _jsxRuntime).jsx("style", {
                    children: style
                }),
                /*#__PURE__*/ (0, _jsxRuntime).jsx("slot", {}),
                /*#__PURE__*/ (0, _jsxRuntime).jsx(Content, {})
            ]
        })
    );
})) {
    get scrollLeft() {
        return this.textarea?.scrollLeft ?? 0;
    }
    get scrollTop() {
        return this.textarea?.scrollTop ?? 0;
    }
};
exports.CodeEditElement = CodeEditElement;
