import { CodeSyntaxElement, languages, SyntaxOrImport } from 'code-syntax';
import { SuperImposeElement } from 'super-impose';
import { TextAreaCodeElement } from 'textarea-code';
export { languages };
export type { SyntaxOrImport };
declare global {
    namespace JSX {
        interface IntrinsicAttributes {
            theme?: string;
        }
    }
}
declare const CodeEditElement_base: {
    new (): HTMLElement;
    prototype: HTMLElement;
} & import("mixter").Class<import("mixter").Root> & import("mixter").Class<{
    addEventListener<K extends "scroll">(type: K, listener: any, options?: any): void;
    dispatch(name: string, detail?: any, init?: CustomEventInit<any> | undefined): any;
} & import("mixter").InlineEventMap<{
    new (): HTMLElement;
    prototype: HTMLElement;
} & import("mixter").Class<import("mixter").Root>, {
    scroll: Event;
}>> & import("mixter").Class<import("mixter").PropsType<{
    /** The editor's value */
    value: string;
    /** Autofocus to the element when page loads */
    autoFocus: boolean;
    /** Whether to autoresize to the height of the contents */
    autoResize: boolean;
    /** Language for syntax highlighting */
    language: string;
    /** Theme to use */
    theme: string;
    /** Tab size */
    tabSize: number;
    /** Tab style */
    tabStyle: 'spaces' | 'tabs';
    /** Comment */
    comments: string;
}>> & import("mixter").Class<{
    /** @private */
    CodeSyntax: import("html-vdom/from-element").Component<CodeSyntaxElement, unknown>;
    /** @private */
    SuperImpose: import("html-vdom/from-element").Component<SuperImposeElement, unknown>;
    /** @private */
    TextAreaCode: import("html-vdom/from-element").Component<TextAreaCodeElement, unknown>;
    /** Passing a syntax definition regexp manually */
    syntax: SyntaxOrImport;
    /** @private */
    textarea?: TextAreaCodeElement | undefined;
    /** @private */
    layout?: SuperImposeElement | undefined;
    /** @private */
    height?: HTMLPreElement | undefined;
    /** @private */
    onInput?: (() => void) | undefined;
    /** @private */
    onScroll?: (() => void) | undefined;
}> & import("mixter").Class<{
    host: HTMLElement & import("mixter").Root & {
        addEventListener<K extends "scroll">(type: K, listener: any, options?: any): void;
        dispatch(name: string, detail?: any, init?: CustomEventInit<any> | undefined): any;
    } & import("mixter").InlineEventMap<{
        new (): HTMLElement;
        prototype: HTMLElement;
    } & import("mixter").Class<import("mixter").Root>, {
        scroll: Event;
    }> & import("mixter").PropsType<{
        /** The editor's value */
        value: string;
        /** Autofocus to the element when page loads */
        autoFocus: boolean;
        /** Whether to autoresize to the height of the contents */
        autoResize: boolean;
        /** Language for syntax highlighting */
        language: string;
        /** Theme to use */
        theme: string;
        /** Tab size */
        tabSize: number;
        /** Tab style */
        tabStyle: 'spaces' | 'tabs';
        /** Comment */
        comments: string;
    }> & {
        /** @private */
        CodeSyntax: import("html-vdom/from-element").Component<CodeSyntaxElement, unknown>;
        /** @private */
        SuperImpose: import("html-vdom/from-element").Component<SuperImposeElement, unknown>;
        /** @private */
        TextAreaCode: import("html-vdom/from-element").Component<TextAreaCodeElement, unknown>;
        /** Passing a syntax definition regexp manually */
        syntax: SyntaxOrImport;
        /** @private */
        textarea?: TextAreaCodeElement | undefined;
        /** @private */
        layout?: SuperImposeElement | undefined;
        /** @private */
        height?: HTMLPreElement | undefined;
        /** @private */
        onInput?: (() => void) | undefined;
        /** @private */
        onScroll?: (() => void) | undefined;
    };
    isMounted?: boolean | undefined;
}>;
/**
 * CodeEdit custom element
 *
 * ```js
 * import { CodeEditElement } from 'code-edit'
 * customElements.define('code-edit', CodeEditElement)
 * ```
 *
 * ```html
 * <code-edit autofocus autoresize language="js" theme="deep"> ... </code-edit>
 * ```
 */
export declare class CodeEditElement extends CodeEditElement_base {
    get scrollLeft(): number;
    get scrollTop(): number;
}
